/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


/***************************************************************************
*The dictionary proper
*(C) Eduardo Rodriguez 2005
*
*HISTORY: 24/10/2005 Created
TODO
set limit for edit box
annoying scrolling flicker

****************************************************************************/

#include <windows.h>
#include <string.h>
#include "searcher.h"
#include "controles/MEControls.h"
#include "buttonManager.h"


/*************************
*DATA MEMBERS
**************************/
#define DOWN 1
#define UP 0
#define OVER 2

const char g_MEDiccionarioX[]="mediccionariox";
extern int docked;
extern HDC memdc;
extern HBITMAP bm;
static HWND thisdic=NULL,thescroll=NULL,theedit=NULL;
static int buscar=UP;
static int dicw,dich;
static HWND combo1,combo2;




//////////////////////////////////////////////////////////////////////////////////////
/***********************************METHODS ("PRIVATE")*****************************/
///////////////////////////////////////////////////////////////////////////////////////

static void initTT()
{
       addToolTip(theedit,0,0,135,20,"Introduce aqu la palabra \ncon la que quieras rimar\n");  
       addToolTip(combo1,0,0,40,16,"Especifica el nmero de \nslabas que quieras que tengan \nlos resultados, o \"N/A\" si \nte es indiferente\n");  
       addToolTip(combo2,0,0,40,16,"Especifica si quieres que los resultados \ncomiencen por vocal o h (VoH), \nconsonante (Con), \no si te es indiferente (N/A)\n");  
       addToolTip(thisdic,145,1,59,19,"Haz click aqu para \ncomenzar la bsqueda\n");  
            
       
}


static void PaintMEDiccionario(HWND hwnd)
{
    //blablabla
    PAINTSTRUCT Ps;
    HDC hDC = BeginPaint(hwnd, &Ps);
    HDC MemDC= CreateCompatibleDC(hDC);
    HBRUSH bk1=NULL;
    HPEN bk2=NULL;
    //w
    RECT rec;
    GetWindowRect(hwnd,&rec);
    dicw=rec.right-rec.left;
    dich=rec.bottom-rec.top;
    int kk;
    
    //paint first back
    SelectObject(MemDC,bm);
    for(kk=0;kk<dicw;kk+=5)
     BitBlt(memdc, kk, 0,5,20 , MemDC, 59, 74, SRCCOPY); 


    bk1=CreateSolidBrush(GetPixel(MemDC,0,334));
    bk2=CreatePen(PS_SOLID, 1, GetPixel(MemDC,0,334)); 
    //paint button
    if(buscar==UP)
    kk=11;
    else if(buscar==DOWN)
    kk=70;
    else
    kk=129;
    BitBlt(memdc, 145, 1,59,19 , MemDC, kk, 52, SRCCOPY); 
    
    //paint second bg
    SelectObject(memdc,bk1);
    SelectObject(memdc,bk2);
    Rectangle(memdc,0,20,dicw,dich);  

     //paint label
    BitBlt(memdc, 0, 25,dicw,16 , MemDC, 92, 152, SRCCOPY); 

    
     //double buffering               
    BitBlt(hDC, 0, 0,dicw,dich , memdc, 0, 0, SRCCOPY); 
   
    
    //blablabla 
    DeleteObject(bk1);
    DeleteObject(bk2);          
    DeleteDC(hDC);
    DeleteDC(MemDC);
    EndPaint(hwnd, &Ps);              
}





static void commandEntered(BOOL button)
{
    //was it a carriage return?
    int kk,jj=-1,ll=0;
    char *buffer2="\0";
    char buffer3[200];
    char buffer[200];
    for (kk=0;kk<200;kk++)
    {
        buffer[kk]='\0';
        buffer3[kk]='\0';
    }
    SendMessage(theedit,WM_GETTEXT,200,(UINT)buffer);
    for(kk=0;kk<200;kk++)
    {
        if(buffer[kk]!='\r' && buffer[kk]!=' ' && buffer[kk]!='\n' && buffer[kk]!='\t')
        {
            buffer3[ll]=buffer[kk];
            ll++;                    
        }                 
                         
        if(buffer[kk]=='\r' || (button && buffer[kk]=='\0'))
        {
           if(strlen(buffer3)>0)
           {
               HWND but=newButt(buffer3,GetSelectedMEComboBox(combo1),GetSelectedMEComboBox(combo2));
               pasoUno(buffer3,GetSelectedMEComboBox(combo2),GetSelectedMEComboBox(combo1),but);
 
            }
           SendMessage(theedit,WM_SETTEXT,0,(UINT)buffer2);                                 
           kk=201;                                        
        }           
    }                         
}









LRESULT CALLBACK MEDiccionarioProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
        case WM_NCHITTEST:
        {
            //get coordinates
            UINT uHitTest = DefWindowProc(hwnd, WM_NCHITTEST, wParam, lParam);
            int xPos = LOWORD(lParam); 
            int yPos = HIWORD(lParam);
            RECT wind; 
            GetWindowRect(hwnd,&wind);
            xPos-=wind.left;
            yPos-=wind.top;
            if(xPos>145 && xPos<204 && yPos<20)
            {
                 if(buscar!=DOWN)   
                 buscar=OVER;
                 TRACKMOUSEEVENT tr;
                 tr.cbSize=sizeof(tr);
                 tr.dwFlags=TME_LEAVE;
                 tr.hwndTrack=hwnd;
                 tr.dwHoverTime=HOVER_DEFAULT;
                 TrackMouseEvent(&tr);
            }
            else
            buscar=UP;
            InvalidateRect(hwnd,NULL,FALSE);        
            UpdateWindow(hwnd);        
            
            
            
            
        }
        break;

        case ME_SCROLL_VERTICAL:
        {           
            scrollButton(wParam,TRUE); 
            InvalidateRect(hwnd,NULL,FALSE);        
            UpdateWindow(hwnd);        
  
        }   
        break;


        case WM_CREATE:
           combo1=CreateMEComboBox(hwnd,60,25,40,16,40,64,12,
                      "N/A,1,2,3,4,5,6,7,8,9,", 
                      "Times New Roman",14,10); 
           combo2=CreateMEComboBox(hwnd,165,25,40,16,40,48,12,
                      "N/A,VoH,Con,", 
                      "Times New Roman",14,3); 
           theedit=CreateWindow( "EDIT", NULL, WS_BORDER|WS_CHILD| WS_VISIBLE| ES_LOWERCASE|ES_AUTOHSCROLL|ES_AUTOVSCROLL|ES_MULTILINE, 
            5,1, 135, 20, hwnd, NULL, GetModuleHandle(NULL), NULL);
           SendMessage(theedit,(UINT)EM_SETLIMITTEXT,(WPARAM) 100,(LPARAM) 0);
           thescroll=CreateMEScroll(hwnd,dicw-11,47,11,dich-47,0,0,(dich-47)/24,TRUE);    
           InitDicButton(hwnd);
           InitButManager(hwnd,thescroll,dicw,dich);

           SetFocus(theedit);
        break;       
               
               
        case WM_COMMAND:
            if(HIWORD(wParam)==EN_CHANGE)
            {
                commandEntered(FALSE);                             
            }                             
        break;       
               
        case WM_PAINT:
            PaintMEDiccionario(hwnd);     
        break;            
            
        case WM_LBUTTONDOWN:
        {
            int xPos = LOWORD(lParam); 
            int yPos = HIWORD(lParam);
            if(xPos>145 && xPos<204 && yPos<20)
            {
                TRACKMOUSEEVENT tr;
                tr.cbSize=sizeof(tr);
                tr.dwFlags=TME_LEAVE;
                tr.hwndTrack=hwnd;
                tr.dwHoverTime=HOVER_DEFAULT;
                TrackMouseEvent(&tr);
                buscar=DOWN;
  	            InvalidateRect(hwnd,NULL,FALSE);        
                UpdateWindow(hwnd); 
            }                   
        }    
        break;    
        
        
        case WM_LBUTTONUP:
        {
            int xPos = LOWORD(lParam); 
            int yPos = HIWORD(lParam);
            if(xPos>145 && xPos<204 && yPos<20)
            {
                buscar=OVER;
                commandEntered(TRUE); 
            } 
            else
                buscar=UP;    
            InvalidateRect(hwnd,NULL,FALSE);        
            UpdateWindow(hwnd);               
        }    
        break;    
         
       case WM_ERASEBKGND:
            //to avoid flickering while scrolling
            if(isOpen())
                PaintMEDiccionario(hwnd);
       return 1;
 
        
        case WM_MOUSELEAVE:
            buscar=UP;
            InvalidateRect(hwnd,NULL,FALSE);        
            UpdateWindow(hwnd);        
        break;
        
               
        default:
            return DefWindowProc (hwnd, msg, wParam, lParam);            
        break;           
    }


           return DefWindowProc (hwnd, msg, wParam, lParam);        
 
}




////////////////////////////////////////////////////////////////////////////////////
/****************************METHODS ("PUBLIC")************************************/
////////////////////////////////////////////////////////////////////////////////////
void CreateMEDiccionario(HWND parent,int y,int w,int h)
{
 
    WNDCLASSEX wc;

    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = MEDiccionarioProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = GetModuleHandle(0);
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = CreateSolidBrush(RGB(0,0,0));;
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_MEDiccionarioX;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    RegisterClassEx(&wc); 
    dicw=w;
    dich=h;
    thisdic=CreateWindowEx(0,g_MEDiccionarioX, "",WS_VISIBLE|WS_CHILD|WS_CLIPCHILDREN,
    0, y, dicw, h,parent, NULL, GetModuleHandle(0), NULL);  
           initTT();
}



void NewSizeMEDiccionario(int w,int h)
{
  dicw=w;
  dich=h;   
  if(docked==0)
      SetWindowPos(thisdic,0,0,32,dicw,dich,0); 
  else
      SetWindowPos(thisdic,0,0,17,dicw,dich,0);
  InvalidateRect(thisdic,NULL,FALSE);        
  UpdateWindow(thisdic); 
  newSize(dicw,dich);
  setscreensizeMESCroll(thescroll,(dich-47)/24);
  resizeMEScroll(thescroll,11,dich-47);  
  //setMaxHeight(dich); 
}

