/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/

#include <windows.h>
#include "fonetica.h"


#define DOWN 1
#define UP 0
#define OVER 2
#define RIGHT 2
#define ID_FILE_EXIT 0

/*************************
*DATA MEMBERS
**************************/



const char g_fonetica[]="fonetica";
extern HBITMAP bm;
extern HDC memdc;

static HWND thisfonetica=NULL;
static HWND hwndp=NULL;
static int widthfonetica=300;
static int heightfonetica=210;
static int cerrarfonetica=UP;
static int flags=0;
static int aceptar=UP;
static int cerrar=UP;
static BOOL thereis=FALSE;


///////////////////////////////////////////////////////////////////////////////////////
/**********************************METHODS ("PRIVATE")*******************************/
////////////////////////////////////////////////////////////////////////////////////////

/*****************************
*PAINT
*****************************/


static void paintFonetica()
{
     //blablabla
     PAINTSTRUCT Ps;
     HDC hDC = BeginPaint(thisfonetica, &Ps);
     HDC MemDC= CreateCompatibleDC(hDC);
     SelectObject(MemDC,bm);
     int kk;
     //get colors
     COLORREF c1,c2,c3,c4;
     c4=GetPixel(MemDC,14,0);    //texto "palabra original"
     c3=GetPixel(MemDC,16,0);   //texto , palabra
     c1=GetPixel(MemDC,0,335);  //bg
     c2=GetPixel(MemDC,92,168); //borde
     HPEN p1=CreatePen(PS_SOLID, 1, c2);
     HBRUSH b1=CreateSolidBrush(c1);
     HFONT hf = CreateFont(16, 0, 0, 0,0, FALSE, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");   
     
     SelectObject(memdc,p1);
     SelectObject(memdc,b1); 
     SelectObject(memdc,hf);
     
     //bg
     Rectangle(memdc,0,0,widthfonetica,heightfonetica);
 
     //title
     for(kk=0;kk<widthfonetica;kk+=50)
     BitBlt(memdc, kk, 0, 50,18 , MemDC, 92, 169, SRCCOPY);
     
     BitBlt(memdc, 5, 0, 86,18 , MemDC, 341, 169, SRCCOPY);
     
     
     MoveToEx(memdc,0,0,NULL);
     LineTo(memdc,0,20);
     MoveToEx(memdc,widthfonetica-1,0,NULL);
     LineTo(memdc,widthfonetica-1,20); 

     //tilte buttons
     
		     //close button
             if(cerrarfonetica==UP)
             BitBlt(memdc, widthfonetica-19, 4, 12, 12, MemDC, 11, 11, SRCCOPY);
             else if(cerrarfonetica==DOWN)
             BitBlt(memdc, widthfonetica-19, 4, 12, 12, MemDC, 23, 11, SRCCOPY);
             else
             BitBlt(memdc, widthfonetica-19, 4, 12, 12, MemDC, 35, 11, SRCCOPY);


     //text
     SetBkColor(memdc,c1);  
     SetTextColor(memdc,c3);  

     if(flags&ME_F_Y)
         BitBlt(memdc, 20, 70, 11, 11, MemDC, 258, 32, SRCCOPY);   
     else
         BitBlt(memdc, 20, 70, 11, 11, MemDC, 269, 32, SRCCOPY);          

     if(flags&ME_F_Z)
         BitBlt(memdc, 20, 100, 11, 11, MemDC, 258, 32, SRCCOPY);   
     else
         BitBlt(memdc, 20, 100, 11, 11, MemDC, 269, 32, SRCCOPY);          
 
     if(flags&ME_F_C)
         BitBlt(memdc, 20, 130, 11, 11, MemDC, 258, 32, SRCCOPY);   
     else
         BitBlt(memdc, 20, 130, 11, 11, MemDC, 269, 32, SRCCOPY);          

     TextOut(memdc,20,30,"\"v=b\", acentos y \"y=i al final de la palabra\"",45);
     TextOut(memdc,20,46,"son implementados por defecto.",31);
     SetTextColor(memdc,c4);
     TextOut(memdc,40,67,"y=ll",5);
     TextOut(memdc,40,97,"z=s",4); 
     TextOut(memdc,40,127,"ce/ci=se/si",12);
     
     //buttons
     if(aceptar==UP)
         BitBlt(memdc,75, 170, 51, 19, MemDC, 255, 269, SRCCOPY); 
     else if(aceptar==OVER)
         BitBlt(memdc,75, 170, 51, 19, MemDC, 306, 269, SRCCOPY);        
     else
         BitBlt(memdc,75, 170, 51, 19, MemDC, 357, 269, SRCCOPY);     
     
     if(cerrar==UP)
         BitBlt(memdc, 175, 170, 51, 19, MemDC, 255, 288, SRCCOPY);       
     else if(cerrar==OVER)
         BitBlt(memdc, 175, 170, 51, 19, MemDC, 306, 288, SRCCOPY);       
     else
         BitBlt(memdc, 175, 170, 51, 19, MemDC, 357, 288, SRCCOPY);       
  

     //double buffering
     BitBlt(hDC, 0, 0,widthfonetica,heightfonetica , memdc, 0, 0, SRCCOPY); 

     //clen up
     DeleteDC(hDC);
     DeleteDC(MemDC);
     DeleteObject(p1);
     DeleteObject(b1);
     DeleteObject(hf);
     EndPaint(thisfonetica, &Ps);                       
}



/******************************
*CALLBACK PROCEDURE
*******************************/

LRESULT CALLBACK foneticaProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{

  switch(msg)
    {
  
  
    //---------------------------WM_NCHITTEST-------------------------           
    case WM_NCHITTEST:
    {
      //find coordinates   
      int xPos = LOWORD(lParam); 
      int yPos = HIWORD(lParam);
      int pos,w,h;
      RECT wind;
      GetWindowRect(hwnd,&wind);
      yPos-=wind.top;
      xPos-=wind.left;


      //it cerrarfonetica
      if( yPos>4 && yPos<16 && xPos>widthfonetica-19 && xPos<widthfonetica-7)
      {
          if(cerrarfonetica!=OVER && cerrarfonetica!=DOWN)
          {
              cerrarfonetica=OVER;
              TRACKMOUSEEVENT tr;
              tr.cbSize=sizeof(tr);
              tr.dwFlags=TME_LEAVE;
              tr.hwndTrack=hwnd;
              tr.dwHoverTime=0;
              TrackMouseEvent(&tr);
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                   
          }
          return HTCLIENT;
      }
      //if anywhere else in the title bar
      else if(yPos < 20)
      {
          if(cerrarfonetica!=UP )
          {             
              cerrarfonetica=UP; 
              InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);     
          }                 
          return HTCAPTION;  
      }
      //outside the title bar 
      
      //ok, cerrar
      else if(yPos>170 && yPos<189)
      {
           if(xPos>75 && xPos<126 && aceptar==UP)
           {
               aceptar=OVER;
               cerrarfonetica=UP;
               cerrar=UP;
              TRACKMOUSEEVENT tr;
              tr.cbSize=sizeof(tr);
              tr.dwFlags=TME_LEAVE;
              tr.hwndTrack=hwnd;
              tr.dwHoverTime=0;
              TrackMouseEvent(&tr);
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                                 
           }
           else if(xPos>175 && xPos<226 && cerrar==UP)
           {
               aceptar=UP;
               cerrarfonetica=UP;
               cerrar=OVER;
              TRACKMOUSEEVENT tr;
              tr.cbSize=sizeof(tr);
              tr.dwFlags=TME_LEAVE;
              tr.hwndTrack=hwnd;
              tr.dwHoverTime=0;
              TrackMouseEvent(&tr);
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                               
           }
           
      }
      
               
      else
      {   
          if(cerrarfonetica!=UP || cerrar!=UP || aceptar!=UP)
          {
              cerrarfonetica=UP; 
              cerrar=UP;
              aceptar=UP;   
  		      InvalidateRect(hwnd,NULL,FALSE);        
              UpdateWindow(hwnd);                    
          }   
          return DefWindowProc(hwnd, msg, wParam, lParam);                                 
      }
    }
    
    //--------------------------WM_LBUTTONUP------------------------------
    case WM_LBUTTONUP:
    {
         int xPos=LOWORD(lParam); 
         int yPos=HIWORD(lParam);
         if(cerrarfonetica==DOWN || cerrar==DOWN || aceptar==DOWN)
         {
             if(aceptar==DOWN)
                 SendMessage(hwndp,ME_FONETICA,0,0);
             cerrar=UP;
             aceptar=UP;
             cerrarfonetica=UP;
             thereis=FALSE;
             DestroyWindow(hwnd);
         }
         else if(xPos>20 && xPos<31)
         {
             if(yPos>70 && yPos<81)
             {
                 if(flags&ME_F_Y)flags=flags^ME_F_Y;
                 else
                     flags=flags|ME_F_Y;           
                        
             }
             
             else if(yPos>100 && yPos<111)
             {
                 if(flags&ME_F_Z)flags=flags^ME_F_Z;
                 else
                     flags=flags|ME_F_Z;     
             }
             
             else if(yPos>130 && yPos<141)  
             {
                 if(flags&ME_F_C)flags=flags^ME_F_C;
                 else
                     flags=flags|ME_F_C;     
                  
             }   
             InvalidateRect(hwnd,NULL,FALSE);        
             UpdateWindow(hwnd);                          
         }
    }     
    break;
    
    
    //----------------------------WM_MOUSELEAVE----------------------------
    case WM_MOUSELEAVE:
         cerrarfonetica=UP;
         cerrar=UP;
         aceptar=UP;
         InvalidateRect(hwnd,NULL,FALSE);        
         UpdateWindow(hwnd);                    

    break; 
    
    
    //-----------------------------WM_LBUTTONDOWN----------------------
    case WM_LBUTTONDOWN:
         if(cerrarfonetica==OVER)
             cerrarfonetica=DOWN;
         else if(cerrar==OVER)
             cerrar=DOWN;
         else if(aceptar==OVER)
             aceptar=DOWN;
         InvalidateRect(hwnd,NULL,FALSE);        
         UpdateWindow(hwnd);                    
    break; 
    
    //------------------------------WM_MOUSEMOVE-----------------------------
    case WM_MOUSEMOVE:

    break;
    
    
    //--------------------------------WM_NCDESTROY--------------------------
    case WM_NCDESTROY:

    break;
 
            
    
    //--------------------------------WM_PAINT-----------------------------
    case WM_PAINT:
        paintFonetica();
    break;
    
        //--------------------------WM_ERASEBKGND-----------------------------------
        case WM_ERASEBKGND:
        return 1;
    
    
    
    //blablabla
    default:
        break;
  }

  return DefWindowProc(hwnd, msg, wParam, lParam);
}



////////////////////////////////////////////////////////////////////////////////////////
/*******************************METHODS ("PUBLIC")***********************************/
///////////////////////////////////////////////////////////////////////////////////////

/*****************************
*REGISTER THE CLASS

return void;
HWND parent: any valid handle;
********************************/
void InitFonetica(HWND parent,int f,BOOL wind)
{
    flags=f;
  if(wind && !thereis)
  {
    WNDCLASSEX wc;
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         =  0;
    wc.lpfnWndProc   = foneticaProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = GetModuleHandle(0);
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_fonetica;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);
    RegisterClassEx(&wc) ;
    hwndp=parent;
    thisfonetica=CreateWindowEx(0,g_fonetica, "M&E-Fonetica...",WS_POPUP|WS_VISIBLE,
           (GetSystemMetrics(SM_CXSCREEN)-widthfonetica)/2, (GetSystemMetrics(SM_CYSCREEN)-heightfonetica)/2,widthfonetica, heightfonetica,parent, NULL, GetModuleHandle(0), NULL);  
    thereis=TRUE;
  }

}

int getFonetica()
{
    
   return flags;    
}



