#include <windows.h>
#include <string.h>
#include "MEControls.h" 
 


HBITMAP backbuffer=NULL;
BITMAP buck;
UINT * ptPixels;     
HBRUSH bkBrush=NULL;
HPEN hpen_black=NULL,hpen_white=NULL,hpen_darktop=NULL,hpen_medtop=NULL,hpen_lowtop=NULL,hpen_bk=NULL;
HDC memdc;
HBITMAP bm;
 
  
void initializeCanvasME(HWND handleToParent)
{
    
         int g;
         PAINTSTRUCT Ps;
         HDC  hDC = BeginPaint(handleToParent, &Ps);
         BITMAPINFOHEADER bmph;
	     bmph.biWidth= 2000;
	     bmph.biHeight=-2000;
         bmph.biPlanes=1;
	     bmph.biBitCount=32;
	     bmph.biCompression=BI_RGB;
     	 bmph.biSizeImage=0;
	     bmph.biClrUsed=0;
	     bmph.biClrImportant=0;
	     bmph.biSize= sizeof(bmph);
         BITMAPINFO bmpi;
	     bmpi.bmiHeader=bmph;
	     const BITMAPINFO *pbmpi=&bmpi;  
         memdc=CreateCompatibleDC(hDC); 
         backbuffer=CreateDIBSection(memdc,pbmpi,DIB_RGB_COLORS,(void **)&ptPixels, NULL,0);
         HDC hbmOld = SelectObject(memdc, backbuffer);
         GetObject(memdc,sizeof(buck),&buck);     
     	 EndPaint(handleToParent, &Ps);
        
        
}

  
  
    
void initializeMEControls(HWND parent)
{

    hpen_black= CreatePen(PS_SOLID, 1, RGB(0,0,0));
    hpen_white= CreatePen(PS_SOLID, 1, RGB(255,255,255)); 
    hpen_darktop=CreatePen(PS_SOLID, 1, RGB(57,61,74)); 
    hpen_medtop= CreatePen(PS_SOLID, 1, RGB(90,84,98)); 
    hpen_lowtop= CreatePen(PS_SOLID, 1, RGB(135,140,152)); 
    hpen_bk=CreatePen(PS_SOLID, 1, RGB(56,59,56)); 
    bkBrush=CreateSolidBrush(RGB(56,59,56));

    InitToolTipManager(parent);
    initializeCanvasME(parent);
    me_hook_beginWatching(parent);
    InitMEList(parent);
    InitMEScroll(parent);
    InitMEComboBox(parent);
    InitMEToolTip( parent);
}



