/* ***********************************************************************************************
*memousehook.c													
*(c)Eduardo Rodriguez 2005																
*																					
*porpuse:   an inifinite thread to check the mouse position. Max 100 windows can register
            with it
*
*history:	10/10/2005 created															
*********************************************************************************************** */

#include <windows.h>
#include "MEControls.h"

HWND me_hook_handles[100];
int me_hook_registered=0;

/*****************************
*PRIVATE
****************************/
DWORD WINAPI me_startWatching(LPVOID iValue)
{
      int k=1,jj;
      while(k==1)
      {
         POINT ps;
         GetCursorPos(&ps);
         for(jj=0;jj<me_hook_registered;jj++)
         {
             SendMessage(me_hook_handles[jj],ME_MOUSEPOS,ps.x,ps.y);                              
         }        
         Sleep(200);        
      }
      return 0;
      
}

/*************************************
*TO BE CALLED BY GLOBAL
*************************************/
void me_hook_beginWatching(HWND hwnd)
{
    
     CreateThread(NULL,0,me_startWatching,0,0,NULL);     
     
}

/************************************
*PUBLIC
**********************************/
BOOL registerMEHook(HWND hwnd)
{
    if(me_hook_registered<100)
    {
      me_hook_handles[me_hook_registered]=hwnd;
      me_hook_registered++;
      return TRUE;
    }
    else
      return FALSE;  
    
}
