/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


#include "winsock2.h"
#include <stdio.h>
#include <windows.h>

static char *unparsed;
static char *parsed=NULL;
static char *webpage;
static char *word; 
static BOOL searching=FALSE;
static int error=-1;

static char *men[6]={"ERROR (*.*) :\n\nNo ha podido hallarse la pgina de la RAE.\n\
Posiblemente no ests conectado a internet.",
                     "ERROR m(__)m:\n\nno ha podido establecerse conexin.",
                     "ERROR (O.O):\n\nno ha podido establecerse conexin",
                     "ERROR (;.;):\n\nParece ser que no tienes winsock, la librera de Windows que contiene las rutinas para conectarse a Internet.",
                     "ERROR (#_#):\n\nno ha podido establecerse un conexin.",
                     "ERROR (@.@):\n\nno se ha podido enviar la peticin a buscn.rae.es."};


SOCKET call_socket(const char *hostname, unsigned short portnum) 
{ 
    struct sockaddr_in sa; 
    struct hostent *hp; 
    SOCKET s; 
    hp = gethostbyname(hostname); 
    if (hp == NULL)
    { /* we don't know who this host is */ 
    error=0;
    return INVALID_SOCKET;     
    }
    
    memset(&sa,0,sizeof(sa)); 
    
    memcpy((char *)&sa.sin_addr, (char*)hp->h_addr, hp->h_length); /* set address */ 
 
    sa.sin_family = AF_INET; 
    sa.sin_port =htons( 80 ); 
    s = socket(hp->h_addrtype, SOCK_STREAM, 0); 
    if (s == INVALID_SOCKET)
    { 
          error=1;
          return INVALID_SOCKET; 
    }
          /* try to connect to the specified socket */ 
    if (connect(s, (struct sockaddr *)&sa, sizeof sa) == SOCKET_ERROR) 
    { 
        error=2;           
        closesocket(s); 
        return INVALID_SOCKET; 
    } 
    return s; 
}

DWORD WINAPI me_startrae(LPVOID iValue)
{
    // Initialize Winsock.
    if(parsed!=NULL)
    free(parsed); 

        int bytesSent,kk=0,jj=0,tt=0;
        int bytesRecv = 1;
        BOOL reading=FALSE;
        BOOL finished=FALSE;
        char sendbuf[300]; 
        char recvbuf[1000] = "";        
    SOCKET m_socket;    
    unparsed=malloc(5000*sizeof(char));
    parsed=malloc(5000*sizeof(char));
    char line[1000];
    char check[]="span class=\"eFCompleja\"";
    int pc=0;
    int pav=5000;
    int countch=0;
    int available=5000;
    WSADATA wsaData;
    memset(unparsed,'\0',100);
    memset(parsed,'\0',100);
    int iResult = WSAStartup( MAKEWORD(1,1), &wsaData );

    if(iResult!=NO_ERROR)
    error=3;

    if(error==-1)
    {

        // Create a socket.
        m_socket = call_socket(webpage,80);
    
        if ( m_socket == INVALID_SOCKET ) {
            WSACleanup();
        }
    }

    if(error==-1)
    {

        // Send and receive data.

        for(kk=0;kk<300;kk++)
        sendbuf[kk]='\0';

    
        if(word[0]!='\0')
        sprintf(sendbuf,"POST /draeI/SrvltGUIBusUsual HTTP/1.1\r\nHost: buscon.rae.es\r\nFrom: ---\r\nUser-Agent: Mozilla/5.0 (edu; U; PPC Mac OS X; en) AppleWebKit/416.11 (KHTML, like Gecko) Safari/416.12/1.0\r\nConnection: close\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: %d\r\n\r\nLEMA=%s\r\n\r\n",strlen(word)+5,word);
        else
        sprintf(sendbuf,"GET /index.html HTTP/1.1\r\nHost: %s\r\nFrom: ---\r\nUser-Agent: Mozilla/5.0 (edu; U; PPC Mac OS X; en) AppleWebKit/416.11 (KHTML, like Gecko) Safari/416.12/1.0\r\nConnection: close\r\n\r\n",webpage);
        
    
        bytesSent = send( m_socket, sendbuf, strlen(sendbuf), 0 );
    
        if(bytesSent==0)
        error=5;
    }
    
    if(error==-1)
    {
        while( bytesRecv >0 && searching) 
        {
           memset(recvbuf,'\0',1000);    
           bytesRecv = recv( m_socket, recvbuf, 300, 0 );
           if(countch+bytesRecv>available)
           {
               char* tem=realloc(unparsed,(available+5000)*sizeof(char));
               if(tem!=NULL)
               {
                   available+=5000;
                   unparsed=tem;
               }
               else
                   bytesRecv=0;
           }
           if(bytesRecv!=0)
           {
               strcat(unparsed,recvbuf);
               countch+=bytesRecv;
           }
        }
    
        //parse
        kk=0;
        jj=0;
        while(unparsed[kk]!='\0' && !finished && searching)
        {
            if(unparsed[kk]=='<')
                reading=FALSE;
            else if(unparsed[kk]=='>')
            {
               if(line[0]=='t' && line[1]=='r')
               {
                   parsed[jj]='\t';
                   jj++;              
               }
               else if(strcmp(check,line)==0)
                   finished=TRUE;
               else if(strcmp(line,"/ARTICULO")==0)
                   finished=TRUE;
                 
                 
                //read the tag 
                tt=0;
                memset(line,'\0',500);
                reading=TRUE;
            }

             else if(!reading && tt<1000)
            {
               line[tt]=unparsed[kk];  
               tt++;
            }
            else if(reading)
            {
                if(jj>pav+20)
                {
                    char *temp=realloc(parsed,(pav+5000)*sizeof(char));
                    if(temp!=NULL)
                    {
                        pav+=5000;
                        parsed=temp;              
                    } 
                    else
                    {
                        finished=TRUE;
                    }
                           
                }    
                if(!finished)
                {
                   //deal with utf-8          
                   if(unparsed[kk]==-61)
                   {
                       kk++;
                       switch(unparsed[kk])
                       {
                           case -95:
                                parsed[jj]='';
                           break;
                            case -127:
                                parsed[jj]='';
                           break;
                           case -87:
                                parsed[jj]='';
                           break;
                           case -119:
                                parsed[jj]='';
                           break;
                           case -83:
                                parsed[jj]='';
                           break;
                           case -115:
                                parsed[jj]='';
                           break;
                           case -77:
                                parsed[jj]='';
                           break;
                           case -109:
                                parsed[jj]='';
                           break;
                           case -70:
                                parsed[jj]='';
                           break;
                           case -102:
                                parsed[jj]='';
                           break;
                           case -68:
                                parsed[jj]='';
                           break;
                           case -100:
                                parsed[jj]='';
                           break;
                           case -79:
                                parsed[jj]='';
                           break;
                           case -111:
                                parsed[jj]='';
                           break;
                           default:
                                parsed[jj]='-';  
                           break;
                       
                                           
                                           
                       }                     
                                        
                                        
                   }
                             
                    else        
                        parsed[jj]=unparsed[kk];
                    jj++;                      
                }
                
            }
            

                              
                              
            kk++;                      
        }

        parsed[jj]='\0';
        free(unparsed);
        kk=0;
        BOOL lastn=FALSE;
        while(parsed[kk]!='\0')
        {
                               
            if(parsed[kk]=='\n')
            parsed[kk]=' ';
            if(parsed[kk]=='\t')
            parsed[kk]='\n';          
            kk++;               
                               
        }
    }
    if(error<5)
       closesocket(m_socket);       
       WSACleanup();
      if(error!=-1)
      strcat(parsed,men[error]); 
       
      searching=FALSE;
      return 0;
      
}



BOOL issearching()
{
    return searching;     
}

char* getResult()
{
    return parsed;      
}


char* search(char *webp,char *w)
{
  
 webpage=webp;
 word=w;
 error=-1;
 searching=TRUE;
 CreateThread(NULL,0,me_startrae,0,0,NULL);     

    
 return parsed;    
     
}



