/************************************************************************************************************************************************
*(C)Eduardo Rodriguez Lorenzo 2005. Este archivo se distribuye bajo los terminos de la licencia GPL de la GNU. Puedes encontrar esta licencia en el archivo
leeme.txt que deberas haber recibido con esta distribucin
*
***************************************************************************************************************************************/


/*
fonetica tff
sizeX sizeY
posX posY
tooltips t
acoplar t

*/
#include <stdio.h>
#include <windows.h>
#include <string.h>
#include "settings.h"
#include "fonetica.h"



int charToInt(char* num)
{
   int l=strlen(num),kk;
   int result=0;
   int going=1;
   for(kk=l-2;kk>=0;kk--)
   {
     result+=((int)num[kk]-48)*going;
     going*=10;        
                         
   }
    
    return result;
}



void initSettings(int *fonetica,int *sizeX,int *sizeY,int *posX,int *posY,BOOL *acoplar,BOOL *ayuda)
{
    //do defaults just in case
    *fonetica=0;
    *fonetica=*fonetica|ME_F_Y;
    *sizeX=214;
    *sizeY=500;
    *posX=100;
    *posY=100;
    *acoplar=TRUE;
    *ayuda=TRUE;
    FILE *f=fopen("BaseDeDatos/settings.txt","r");
    char fo[10];
    char sX[10];
    char sY[10];
    char pX[10];
    char pY[10];
    char ac[10];
    char ay[10];
    
    memset(fo,'\0',10);
    memset(sX,'\0',10);
    memset(sY,'\0',10);
    memset(pX,'\0',10);
    memset(pY,'\0',10);
    memset(ac,'\0',10);
    memset(ay,'\0',10);    
    if(f!=NULL)
    {
        fgets(fo,10,f);    
        fgets(sX,10,f);    
        fgets(sY,10,f);    
        fgets(pX,10,f);    
        fgets(pY,10,f);    
        fgets(ac,10,f);    
        fgets(ay,10,f);    
     
    
        if(fo[0]=='f')*fonetica=*fonetica^ME_F_Y;
        if(fo[1]=='t')*fonetica=*fonetica|ME_F_Z;
        if(fo[2]=='t')*fonetica=*fonetica|ME_F_C;
        *sizeY=charToInt(sY);
        *posX=charToInt(pX);
        *posY=charToInt(pY);
        if(ac[0]=='f')*acoplar=FALSE;
        if(ay[0]=='f')*ayuda=FALSE;
        
        
        
        fclose(f);
    }
}

void saveSettings(int fonetica,int sizeX,int sizeY,int posX,int posY,BOOL acoplar,BOOL ayuda)
{
  char line[1000];
  char sets[5];
  FILE *f;
  memset(line,'\0',1000);
  if(fonetica&ME_F_Y)sets[0]='t';
  else
      sets[0]='f';
  if(fonetica&ME_F_Z)sets[1]='t';
  else
      sets[1]='f';
  if(fonetica&ME_F_C)sets[2]='t';
  else
      sets[2]='f';
  if(acoplar)sets[3]='t';
  else
      sets[3]='f';
  if(ayuda)sets[4]='t';
  else
      sets[4]='f';
      
  sprintf(line,"%c%c%c\n%d\n%d\n%d\n%d\n%c\n%c\n",sets[0],sets[1],sets[2],sizeX,sizeY,posX,posY,sets[3],sets[4]);
  f=fopen("BaseDeDatos/settings.txt","w");
  if(f!=NULL)
  {
      fputs(line,f);
      fclose(f);           
  }
     
     
     
}



